package com.zd.airbottle.service;

import java.util.List;
import com.zd.airbottle.domain.QpSupplier;
import com.zd.airbottle.domain.dto.QpSupplierDto;
import com.zd.airbottle.domain.vo.QpSupplierVo;

/**
 * 供应商Service接口
 * 
 * @author zd
 * @date 2022-05-10
 */
public interface IQpSupplierService 
{
    /**
     * 查询供应商
     * 
     * @param id 供应商主键
     * @return 供应商
     */
    QpSupplierVo selectQpSupplierVoById(Long id);

    /**
     * 小程序端根据登录用户获取供应商详细信息
     * @return 供应商数据
     */
    QpSupplierVo getDetail();

    /**
     * 根据ID查询供应商信息
     * @param id 供应商主键
     * @return 供应商信息
     */
    QpSupplier selectQpSupplierById(Long id);

    /**
     * 查询供应商列表
     *
     * @param qpSupplier 供应商
     * @return 供应商集合
     */
    List<QpSupplier> getList(QpSupplier qpSupplier);

    /**
     * 查询供应商列表
     * 
     * @param list 供应商
     * @return 供应商集合
     */
    List<QpSupplierVo> getVoList(List<QpSupplier> list);

    /**
     * 根据账号ID查询供应商
     *
     * @param accountId 供应商账号ID
     * @return 供应商集合
     */
    QpSupplier selectQpSupplierByAccountId(Long accountId);

    /**
     * 新增供应商
     * 
     * @param qpSupplierDto 供应商信息
     * @return 结果
     */
    int insertQpSupplier(QpSupplierDto qpSupplierDto);

    /**
     * 修改供应商
     *
     * @param qpSupplierDto 供应商
     * @param isAudit 是否需要审核
     * @return 结果
     */
    int updateQpSupplier(QpSupplierDto qpSupplierDto, boolean isAudit);

    /**
     * 修改供应商审核状态
     *
     * @param qpSupplier 供应商
     * @return 结果
     */
    int updateQpSupplierStatus(QpSupplier qpSupplier);

    /**
     * 批量删除供应商
     * 
     * @param ids 需要删除的供应商主键集合
     * @return 结果
     */
    int deleteQpSupplierByIds(Long[] ids);

    /**
     * 删除供应商信息
     * 
     * @param id 供应商主键
     * @return 结果
     */
    int deleteQpSupplierById(Long id);

    /**
     * 供应商名称校验
     * @param name 名称
     * @param type 类型
     * @return 返回值
     */
    Boolean checkName(String name, Integer type);

    /**
     * 根据ID批量查询供应商
     * @param ids id集合
     * @return 结果集
     */
    List<QpSupplier> selectQpSupplierListByIds(Long[] ids);

    /**
     * 供应商注册
     * @param qpSupplierDto 供应商信息
     * @return 返回值
     */
    boolean register(QpSupplierDto qpSupplierDto);

    /**
     * 查询供应商列表
     *
     * @param qpSupplier 供应商
     * @return 供应商集合
     */
    List<QpSupplier> checkList(QpSupplier qpSupplier);

    /**
     * 根据主键查询供应商信息
     * @param ids 主键集合
     * @return 供应商集合
     */
    List<QpSupplier> getByIds(List<Long> ids);
}
